VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "colRings"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"No"
Attribute VB_Ext_KEY = "Collection" ,"clsRing"
Attribute VB_Ext_KEY = "Member0" ,"clsRing"
Option Explicit

'local variable to hold collection
Private mCol As Collection

Public Function Add(sngCurrentX As Single, sngCurrentY As Single, sngAngle As Single, lngLastUpdateTick As Long, intCurrentMotionLength As Integer, intDesiredMotionLength As Integer, sngDesiredX As Single, sngDesiredY As Single, intMotionRings As Integer, Optional sKey As String) As clsRing
    'create a new object
    Dim objNewMember As clsRing
    Set objNewMember = New clsRing


    'set the properties passed into the method
    objNewMember.mvarsngStartX = sngCurrentX
    objNewMember.mvarsngStartY = sngCurrentY
    objNewMember.sngAngle = sngAngle
    objNewMember.lngLastUpdateTick = lngLastUpdateTick
    objNewMember.intCurrentMotionLength = intCurrentMotionLength
    objNewMember.intDesiredMotionLength = intDesiredMotionLength
    objNewMember.sngDesiredX = sngDesiredX
    objNewMember.sngDesiredY = sngDesiredY
    objNewMember.intMotionRings = intMotionRings
    objNewMember.LastMoveTick = timeGetTime
    objNewMember.SpeedCoefficient = 5000

    With objNewMember
        .sngCurrentX = sngCurrentX
        .sngCurrentY = sngCurrentY
    
        .mvarsngNextX = -1 + Rnd * 2
        .mvarsngNextY = -1 + Rnd * 2
        .mvarsngNext2X = -1 + Rnd * 2
        .mvarsngNext2Y = -1 + Rnd * 2
        .sngDesiredX = -1 + Rnd * 2
        .sngDesiredY = -1 + Rnd * 2
    End With

'               objNewMember.mvarsngNextX = -0.5 + Rnd * 1.5
'               objNewMember.mvarsngNextY = -0.5 + Rnd * 1.5
'               objNewMember.mvarsngNext2X = -0.5 + Rnd * 1.5
'               objNewMember.mvarsngNext2Y = -0.5 + Rnd * 1.5
'               objNewMember.sngDesiredX = -0.5 + Rnd * 1.5
'               objNewMember.sngDesiredY = -0.5 + Rnd * 1.5
                

    If Len(sKey) = 0 Then
        mCol.Add objNewMember
    Else
        mCol.Add objNewMember, sKey
    End If


    'return the object created
    Set Add = objNewMember
    Set objNewMember = Nothing


End Function

Public Property Get Item(vntIndexKey As Variant) As clsRing
Attribute Item.VB_UserMemId = 0
    'used when referencing an element in the collection
    'vntIndexKey contains either the Index or Key to the collection,
    'this is why it is declared as a Variant
    'Syntax: Set foo = x.Item(xyz) or Set foo = x.Item(5)
  Set Item = mCol(vntIndexKey)
End Property



Public Property Get Count() As Long
    'used when retrieving the number of elements in the
    'collection. Syntax: Debug.Print x.Count
    Count = mCol.Count
End Property


Public Sub Remove(vntIndexKey As Variant)
    'used when removing an element from the collection
    'vntIndexKey contains either the Index or Key, which is why
    'it is declared as a Variant
    'Syntax: x.Remove(xyz)


    mCol.Remove vntIndexKey
End Sub


Public Property Get NewEnum() As IUnknown
Attribute NewEnum.VB_UserMemId = -4
Attribute NewEnum.VB_MemberFlags = "40"
    'this property allows you to enumerate
    'this collection with the For...Each syntax
    Set NewEnum = mCol.[_NewEnum]
End Property


Private Sub Class_Initialize()
    'creates the collection when this class is created
    Set mCol = New Collection
End Sub


Private Sub Class_Terminate()
    'destroys collection when this class is terminated
    Set mCol = Nothing
End Sub

Public Sub Render()
    Dim MyRing As clsRing
    Dim matTemp As D3DMATRIX
    Dim sngCalcAngle As Single
    Dim I As Long
    
    With g_dev
        .SetTextureStageState 0, D3DTSS_ALPHAOP, D3DTOP_MODULATE
        .SetRenderState D3DRS_SRCBLEND, D3DBLEND_SRCALPHA
        .SetRenderState D3DRS_DESTBLEND, D3DBLEND_ONE
        .SetRenderState D3DRS_ALPHABLENDENABLE, 1 'True
        .SetTexture 0, texMaterial
    End With
    
    
    '//Loop through all rings
    For Each MyRing In mCol
        With MyRing
    
            For I = 1 To .intMotionRings
                sngCalcAngle = (.sngAngle - (.intCurrentMotionLength * I)) * RAD
                
                D3DXMatrixIdentity g_worldMatrix '//Reset our world matrix
                D3DXMatrixIdentity matTemp
                D3DXMatrixRotationX matTemp, sngCalcAngle
                D3DXMatrixMultiply g_worldMatrix, g_worldMatrix, matTemp
    
                D3DXMatrixIdentity matTemp
                D3DXMatrixRotationY matTemp, sngCalcAngle
                D3DXMatrixMultiply g_worldMatrix, g_worldMatrix, matTemp
                
                D3DXMatrixIdentity matTemp
                D3DXMatrixTranslation matTemp, .sngCurrentX, 0, .sngCurrentY

                D3DXMatrixMultiply g_worldMatrix, g_worldMatrix, matTemp
                g_dev.SetTransform D3DTS_WORLD, g_worldMatrix
                
                With Material
                    .diffuse = LONGtoD3DCOLORVALUE(D3DColorMake(1, 1, 1, 0))
                    .diffuse.a = 1 - (0.12 * I)
                    .Ambient = .diffuse
                    .Specular = LONGtoD3DCOLORVALUE(D3DColorMake(1, 1, 1, 0))
                    .Specular.a = 1 - (0.15 * I)
                    .power = 50
                    .emissive = LONGtoD3DCOLORVALUE(D3DColorMake(0.1, 0.1, 0.1, 0))
                    .emissive.a = 1 '- (0.15 * i)
                End With
                g_dev.SetMaterial Material
                
                m_d3dx_mesh.DrawSubset 0&
            Next I
        
    
        End With
    Next

    g_dev.SetTexture 0, Nothing
End Sub

Public Sub Update()
    Dim MyRing As clsRing
    Dim myTime As Long
    
    '//Loop through all rings
    For Each MyRing In mCol
        With MyRing
            myTime = .lngLastUpdateTick
            .sngAngle = .sngAngle + (.intCurrentMotionLength * ((myTime - timeGetTime) / .SpeedCoefficient) + 1)
            .lngLastUpdateTick = timeGetTime
            
            CubicSpline MyRing
            .intCurrentMotionLength = InterpolateMotionLength(.intDesiredMotionLength, .intCurrentMotionLength)
        End With
    Next
End Sub

Private Sub CubicSpline(MyRing As clsRing)
'Converted from Gamedev.net
Dim lngA As Single, lngB As Single, lngC As Single, lngD As Single
Dim lngE As Single, lngF As Single, lngG As Single, lngH As Single
Dim sngT As Single

    With MyRing
        lngA = .sngDesiredX - 3 * .mvarsngNext2X + 3 * .mvarsngNextX - .mvarsngStartX
        lngB = 3 * .mvarsngNext2X - 6 * .mvarsngNextX + 3 * .mvarsngStartX
        lngC = 3 * .mvarsngNextX - 3 * .mvarsngStartX
        lngD = .mvarsngStartX
        
        lngE = .sngDesiredY - 3 * .mvarsngNext2Y + 3 * .mvarsngNextY - .mvarsngStartY
        lngF = 3 * .mvarsngNext2Y - 6 * .mvarsngNextY + 3 * .mvarsngStartY
        lngG = 3 * .mvarsngNextY - 3 * .mvarsngStartY
        lngH = .mvarsngStartY
    
        sngT = (timeGetTime - .LastMoveTick) / .SpeedCoefficient
        
        .sngCurrentX = lngA * (sngT ^ 3) + lngB * (sngT ^ 2) + lngC * sngT + lngD
        .sngCurrentY = lngE * (sngT ^ 3) + lngF * (sngT ^ 2) + lngG * sngT + lngH
      
        If sngT >= 0.98 Then
                .LastMoveTick = timeGetTime
                .mvarsngStartX = .sngCurrentX
                .mvarsngStartY = .sngCurrentY
                .mvarsngNextX = MyRND(.sngCurrentX + -0.6 + Rnd * 1.2)
                .mvarsngNextY = MyRND(.sngCurrentY + -0.6 + Rnd * 1.2)
                .mvarsngNext2X = MyRND(.mvarsngNextX + -0.2 + (Rnd * 0.4))
                .mvarsngNext2Y = MyRND(.mvarsngNextY + -0.2 + (Rnd * 0.4))
                .sngDesiredX = MyRND(.mvarsngNext2X + -0.2 + (Rnd * 0.4))
                .sngDesiredY = MyRND(.mvarsngNext2Y + -0.2 + (Rnd * 0.4))

                .SpeedCoefficient = 5000 + (Rnd * 3000)
                .intDesiredMotionLength = .SpeedCoefficient / 2000
        End If
                      ' Debug.Print .sngDesiredX, .sngDesiredY
      ' Debug.Print .sngCurrentX, .sngCurrentY
    End With
End Sub

Private Function MyRND(sngRND As Single) As Single
    MyRND = sngRND
    If sngRND < -1.5 Then MyRND = (sngRND / 2 + 0.2 * Rnd)
    If sngRND > 1.5 Then MyRND = (-sngRND / 2 + 0.2 * Rnd)
End Function

Private Function InterpolateMotionLength(sngDesired As Single, sngCurrent As Single) As Single
    If sngCurrent < sngDesired Then
        InterpolateMotionLength = sngCurrent + (sngDesired - sngCurrent) / 10
    Else
        InterpolateMotionLength = sngCurrent - (sngCurrent - sngDesired) / 10
    End If
End Function
